<?php
$lastCodeBlockId = 0;
$codeBlocks = array();
$lastSpoilerBlockId = 0;
$spoilerBlocks = array();
$lastPlainBlockId = 0;
$plainBlocks = array();

function phphighlight($Code) {

    if( floor( phpversion() ) < 4 ){
	
		$Code_table = $Code;
		
    } else {
		
		$Code_Replace_Array = array(
										'<br>',
										'<br />',
										'&gt;',
										'&lt;',
										'&quot;',
										'&amp;',
										'\n',
										'\r',
										'\t'
							);
							
		$Code_Replaced_Array = array(
										'',
										'',
										'>',
										'<',
										'"',
										'\\\\n',
										'\\\\r',
										'\\\\t'
							);
							
		$Code = str_replace($Code_Replace_Array, $Code_Replaced_Array, $Code);

        $Code = trim( stripslashes($Code) );

        ob_start();
		
			$Error_reporting = error_reporting(0);
			
			highlight_string($Code);
			error_reporting($Error_reporting);
			
			$Code = ob_get_contents();
		
        ob_end_clean();

        $Tel_regels = count( explode('<br>', $Code) ) + count( explode('\n', $Code) ) + count( explode('<br />', $Code) );
		$Totaal_regels = $Tel_regels - 1;

		if( $Totaal_regels == 1 ) $Totaal_regels = 2;
			
	    $Code_table = '
		 	<div style="width: 570px; overflow: auto; table-style: fixed; margin-top: 5px; margin-bottom: 5px;">
				<b>Code</b>
				<table width="550" border="0" cellpadding="0" cellspacing="0" style="border: 1px solid black; font-family: Courier New; font-size: 12px; ">
					<tr>
						<td width="20" valign="top" style="background-color: #D6D6D6; border-right: 1px solid black; text-align: right; padding-right: 1px;">';

		for( $i = 1; $i < $Totaal_regels; $i++ ){
            $Code_table .= $i.'<br>';
        }
		
        $Code_table .= '
						</td>
       					 <td valign="top" width="530" style="background-color: #FFFFFF; padding-left: 1px;">
       						'.$Code."\n".'
        				</td>
					</tr>
        		</table>
       		</div>';
			
        $Code_table = str_replace('&quot;', '"', $Code_table);
		
	}
	
    return $Code_table;
	
} 

function Quote($Quote_Tekst) {

  $Quote = '<div class="quote_top">Quote:</div>
  <div class="quote">'.stripslashes($Quote_Tekst).'</div><br>';
  
  return $Quote;
  
}

function Spoiler($Spoiler_Tekst){
	
	$Spoiler = '<div class="spoiler_top">Spoiler:</div>
	<div class="spoiler">'.$Spoiler_Tekst.'</div><br>';
	
	return $Spoiler;
	
}

function replaceCodeBlock($codeBlockContent){

	global $lastCodeBlockId, $codeBlocks;

	if( $lastCodeBlockId < 1 ) {
		$codeBlocks[0] = phphighlight($codeBlockContent);
	} else {
		$codeBlocks[$lastCodeBlockId] = phphighlight($codeBlockContent);
	}
	
	$lastCodeBlockId++;
	return '*CODE' . ($lastCodeBlockId - 1) . '*';
	
}

function replaceSpoilerBlock($spoilerBlockContent){

	global $lastSpoilerBlockId, $spoilerBlocks;

	if( $lastSpoilerBlockId < 1 ) {
		$spoilerBlocks[0] = Spoiler($spoilerBlockContent);
	} else {
		$spoilerBlocks[$lastSpoilerBlockId] = Spoiler($spoilerBlockContent);
	}
		
	$lastSpoilerBlockId++;
	return '*SPOILER' . ($lastSpoilerBlockId - 1) . '*';
		
}

function replacePlainBlock($plainBlockContent){

	global $lastPlainBlockId, $plainBlocks;

	if( $lastPlainBlockId < 1 ) {
		$plainBlocks[0] = $plainBlockContent;
	} else {
		$plainBlocks[$lastPlainBlockId] = $plainBlockContent;
	}
		
	$lastPlainBlockId++;
	return '*PLAIN' . ($lastPlainBlockId - 1) . '*';
		
}




//UBB FUNCTIES
function SetUbb($Text) {

	global  $lastPlainBlockId, $plainBlocks, $lastCodeBlockId, $codeBlocks, $lastSpoilerBlockId, $spoilerBlocks,$Global_install_url, $Global_extension;
	
	$Array_UBB = array(
						
						'/\[plain](.+?)\[\/plain]/ise',
						'/\[code](.+?)\[\/code]/ise',
						'/\[spoiler](.+?)\[\/spoiler]/ise',
						'/\[quote](.+?)\[\/quote]/ise',
						'/\[img(.*?)\]http:\/\/(.*?)\[\/img]/si',
					 	'/\[img(.*?)\]http:\/\/(.+?)\[\/img\]/si',
						'/\[imgl(.*?)\]http:\/\/(.*?)\[\/imgl]/si',
						'/\[imgr(.*?)\]http:\/\/(.*?)\[\/imgr]/si',
						'#(^|[\n ])(http://[^ \n\r\t<]*)#is',
						'#(^|[\n ])((ftp://).[^ \t\n\r<]*)#is',
						'#(^|[\n ])((www.).[^ \t\n\r<]*)#is',
						'/\[url=www.(.*?)\][\/url]/si',
						'/\[url=http:\/\/(.*?)\](.+?)\[\/url]/isD',
						'/\[url=https:\/\/(.*?)\](.+?)\[\/url]/isD',
						'/\[url=ftp:\/\/(.*?)\](.+?)\[\/url]/isD',
						'/\[url=callto:\/\/(.*?)\](.+?)\[\/url]/isD',
						'/\[url=irc:\/\/(.*?)\](.+?)\[\/url]/isD',
						'/\[url](.*?)\[\/url]/si',
						'/\[uri=(.*?)\](.*?)\[\/uri]/si',
						'/\[center](.*?)\[\/center]/si',
						'/\[left](.*?)\[\/left]/si',
						'/\[right](.*?)\[\/right]/si',
						'/\[sub](.*?)\[\/sub]/si',
						'/\[sup](.*?)\[\/sup]/si',
						'/\[b](.*?)\[\/b]/si',
						'/\[i](.*?)\[\/i]/si',
						'/\[s](.*?)\[\/s]/si',
						'/\[u](.*?)\[\/u]/si',
						'/\[ot](.*?)\[\/ot]/si',
						'/\[me](.*?)\[\/me]/si',
						'/\[message=(.*?)\](.*?)\[\/message]/si',
						'/\[message=(.*?)\]/si',
						'/\[topic=(.*?)\](.*?)\[\/topic]/si',
						'/\[topic=(.*?)\]/si',
						'/\[forum=(.*?)\](.*?)\[\/forum]/si',
						'/\[forum=(.*?)\]/si',
						'/\[user=(.*?)\](.*?)\[\/user]/si',
						'/\[user=(.*?)\]/si',
					);
					 
	$Array_HTML = array(
	"replacePlainBlock('\\1')",
						"replaceCodeBlock('\\1')",
						"replaceSpoilerBlock('\\1')",
  						"Quote('\\1')",
						'<img src="http://\\2" alt="" onLoad="scaleImage(this)" style="margin: 2px;" \\1>',
						'<img src="http://\\2" alt="" onLoad="scaleImage(this)" style="margin: 2px;" \\1>',
						'<img src="http://\\2" alt="" onLoad="scaleImage(this)" style="margin: 2px;" align="left" \\1>',
						'<img src="http://\\2" alt="" onLoad="scaleImage(this)" style="margin: 2px;" align="right" \\1>',
						'\\1<a href="http://\\2" target="_blank" style="text-decoration:underline;">\\2</a>',
						'\\1<a href="\\2" target="_blank" style="text-decoration:underline;">\\2</a>',
						'\\1<a href="http://\\2" target="_blank" style="text-decoration:underline;">\\2</a>',
						'<a href="http://www.\\1" target="_blank" style="text-decoration:underline;">\\2</a>',
						'<a href="http://\\1" target="_blank" style="text-decoration:underline;">\\2</a>',
						'<a href="https://\\1" target="_blank" style="text-decoration:underline;">\\2</a>',
						'<a href="ftp://\\1" target="_blank" style="text-decoration:underline;">\\2</a>',
						'<a href="callto://\\1" target="_blank" style="text-decoration:underline;">\\2</a>',
						'<a href="irc://\\1" target="_blank" style="text-decoration:underline;">\\2</a>',
						'<a href="\\1" target="_blank">\\1</a>',
						'<a href="'.$Global_install_url.'\\1">\\2</a>',
						'<div style="text-align: center;">\\1</div>',
						'<div style="text-align: left;">\\1</div>',
						'<div style="text-align: right;">\\1</div>',
						'<sub>\\1</sub>',
						'<sup>\\1</sup>',
						'<strong>\\1</strong>',
						'<i>\\1</i>',
						'<s>\\1</s>',
						'<u>\\1</u>',
						'<span class="offtopic">\\1</span>',
						'<span class="metag">* \\1</span>',
						'<a href="'.$Global_install_url.'singlepost'.$Global_extension.'/\\1#\\1">\\2</a>',
						'<a href="'.$Global_install_url.'singlepost'.$Global_extension.'/\\1#\\1">Singlepost: #\\1</a>',
						'<a href="'.$Global_install_url.'topic'.$Global_extension.'/\\1">\\2</a>',
						'<a href="'.$Global_install_url.'topic'.$Global_extension.'/\\1">Topic: #\\1</a>',
						'<a href="'.$Global_install_url.'forum'.$Global_extension.'/\\1">\\2</a>',
						'<a href="'.$Global_install_url.'forum'.$Global_extension.'/\\1">Forum: #\\1</a>',
						'<a href="'.$Global_install_url.'user'.$Global_extension.'/profiel/\\1">\\2</a>',
						'<a href="'.$Global_install_url.'user'.$Global_extension.'/profiel/\\1">User: #\\1</a>',
					);
  
  $Array_Smile_UBB = array(
  							':d',
							':D',
							':r',
							':R',
							':b',
							':B',
							':s',
							':S',
							'8)',
							':\'(',
							'(love)',
							':#',
							'|:',
							':|',
							':(',
							':x',
							':X',
							':)',
							':o',
							':O',
							':p',
							':P',
							':9',
							':t',
							':T',
							'(uhm)',
							':j',
							':J',
							';)',
							'[hr]'
						);
  
  $Array_Smile_HTML = array(
  								'<img src="'.$Global_install_url.'templates/images/smilies/biggrin.gif" alt=":d" border="0">',
								'<img src="'.$Global_install_url.'templates/images/smilies/biggrin.gif" alt=":D" border="0">',
								'<img src="'.$Global_install_url.'templates/images/smilies/braak.gif" alt=":r" border="0">',
								'<img src="'.$Global_install_url.'templates/images/smilies/braak.gif" alt=":R" border="0">',
								'<img src="'.$Global_install_url.'templates/images/smilies/bye.gif" alt=":b" border="0">',
								'<img src="'.$Global_install_url.'templates/images/smilies/braak.gif" alt=":B" border="0">',
								'<img src="'.$Global_install_url.'templates/images/smilies/confused.gif" alt=":s" border="0">',
								'<img src="'.$Global_install_url.'templates/images/smilies/confused.gif" alt=":S" border="0">',
								'<img src="'.$Global_install_url.'templates/images/smilies/cool.gif" alt="8)" border="0">',
								'<img src="'.$Global_install_url.'templates/images/smilies/cry.gif" alt=":\'(" border="0">',
								'<img src="'.$Global_install_url.'templates/images/smilies/love.gif" alt="(love)" border="0">',
								'<img src="'.$Global_install_url.'templates/images/smilies/mad.gif" alt=":#" border="0">',
								'<img src="'.$Global_install_url.'templates/images/smilies/muur.gif" alt="|:" border="0">',
								'<img src="'.$Global_install_url.'templates/images/smilies/nosmile.gif" alt=":|" border="0">',
								'<img src="'.$Global_install_url.'templates/images/smilies/sad.gif" alt=":(" border="0">',
								'<img src="'.$Global_install_url.'templates/images/smilies/shutup.gif" alt=":x" border="0">',
								'<img src="'.$Global_install_url.'templates/images/smilies/shutup.gif" alt=":X" border="0">',
								'<img src="'.$Global_install_url.'templates/images/smilies/smile.gif" alt=":)" border="0">',
								'<img src="'.$Global_install_url.'templates/images/smilies/suprised.gif" alt=":o" border="0">',
								'<img src="'.$Global_install_url.'templates/images/smilies/suprised.gif" alt=":O" border="0">',
								'<img src="'.$Global_install_url.'templates/images/smilies/tongue.gif" alt=":p" border="0">',
								'<img src="'.$Global_install_url.'templates/images/smilies/tongue.gif" alt=":P" border="0">',
								'<img src="'.$Global_install_url.'templates/images/smilies/tongue2.gif" alt=":9" border="0">',
								'<img src="'.$Global_install_url.'templates/images/smilies/tsk.gif" alt=":t" border="0">',
								'<img src="'.$Global_install_url.'templates/images/smilies/tsk.gif" alt=":T" border="0">',
								'<img src="'.$Global_install_url.'templates/images/smilies/uhm.gif" alt="(uhm)" border="0">',
								'<img src="'.$Global_install_url.'templates/images/smilies/wacko.gif" alt=":j" border="0">',
								'<img src="'.$Global_install_url.'templates/images/smilies/wacko.gif" alt=":J" border="0">',
								'<img src="'.$Global_install_url.'templates/images/smilies/wink.gif" alt=";)" border="0">',
								'<hr>'
							);
								
	$Text = preg_replace($Array_UBB, $Array_HTML, $Text);
	$Text = str_replace($Array_Smile_UBB, $Array_Smile_HTML, $Text);
	

	
	for($i = 0; $i < $lastCodeBlockId; $i++){
			$Text = str_replace('*CODE' . $i . '*', $codeBlocks[$i], $Text);
	}
	
	for($i = 0; $i < $lastSpoilerBlockId; $i++){
			$Text = str_replace('*SPOILER' . $i . '*', $spoilerBlocks[$i], $Text);
	}
	for($i = 0; $i < $lastPlainBlockId; $i++){
			$Text = str_replace('*PLAIN' . $i . '*', $plainBlocks[$i], $Text);
	}
	
	


		return $Text;

	
}
	
	


function ubbSig($Sig){

	$Array_Sig_UBB = array(
							'/\[b](.*?)\[\/b]/si',
							'/\[i](.*?)\[\/i]/si',
							'/\[u](.*?)\[\/u]/si',
							'/\[s](.*?)\[\/s]/si',
							'/\[url=www.(.*?)\][\/url]/si',
							'/\[url=(.*?)\](.+?)\[\/url]/isD',
							'/\[url](.*?)\[\/url]/si'
						);
						
	$Array_Sig_HTML = array(
							'<b>\\1</b>',
							'<i>\\1</i>',
							'<u>\\1</u>',
							'<s>\\1</s>',
							'<a href="http://www.\\1" target="_blank" style="text-decoration:underline;">\\2</a>',
							'<a href="\\1" target="_blank" style="text-decoration:underline;">\\2</a>',
							'<a href="\\1" target="_blank" style="text-decoration:underline;">\\1</a>'
						);
									
	$Sig = preg_replace($Array_Sig_UBB, $Array_Sig_HTML, $Sig);
	
	return $Sig;
	
}

function FaqUBB($Faq){
	
	global $Global_install_url;
	
	$Array_Faq_UBB = array(
							'/\[image](.*?)\[\/image]/si'
					);
					
	$Array_Faq_HTML = array(
							'<img src="'.$Global_install_url.'templates/images/\\1" alt="" border="0">'
					);
					
	$Faq = preg_replace($Array_Faq_UBB, $Array_Faq_HTML, $Faq);
	
	return $Faq;	
	
}
							
?>
